Shift.h
Go to the documentation of this file.
/**
* @file
* @brief Header file for Shift effect class
* @author Jonathan Thomas <jonathan@openshot.org>
*
* @section LICENSE
*
* Copyright (c) 2008-2014 OpenShot Studios, LLC
* <http://www.openshotstudios.com/>. This file is part of
* OpenShot Library (libopenshot), an open-source project dedicated to
* delivering high quality video editing and animation solutions to the
* world. For more information visit <http://www.openshot.org/>.
*
* OpenShot Library (libopenshot) is free software: you can redistribute it
* and/or modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* OpenShot Library (libopenshot) is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with OpenShot Library. If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef OPENSHOT_SHIFT_EFFECT_H
#define OPENSHOT_SHIFT_EFFECT_H
#include "../EffectBase.h"
#include <cmath>
#include <stdio.h>
#include <memory>
#include "../Json.h"
#include "../KeyFrame.h"
using namespace std;
namespace openshot
{
/**
* @brief This class shifts the pixels of an image up, down, left, or right, and can be animated
* with openshot::Keyframe curves over time.
*
* Shifting pixels can be used in many interesting ways, especially when animating the movement of the pixels.
* The pixels wrap around the image (the pixels drop off one side and appear on the other side of the image).
*/
class Shift : public EffectBase
{
private:
/// Init effect settings
void init_effect_details();
public:
Keyframe x; ///< Shift the X coordinates (left or right)
Keyframe y; ///< Shift the Y coordinates (up or down)
/// Blank constructor, useful when using Json to load the effect properties
Shift();
/// Default constructor, which takes 2 curve. The curves will shift the pixels up, down, left, or right
///
/// @param x The curve to adjust the x shift (between -1 and 1, percentage)
/// @param y The curve to adjust the y shift (between -1 and 1, percentage)
Shift(Keyframe x, Keyframe y);
/// @brief This method is required for all derived classes of EffectBase, and returns a
/// modified openshot::Frame object
///
/// The frame object is passed into this method, and a frame_number is passed in which
/// tells the effect which settings to use from it's keyframes (starting at 1).
///
/// @returns The modified openshot::Frame object
/// @param frame The frame object that needs the effect applied to it
/// @param frame_number The frame number (starting at 1) of the effect on the timeline.
std::shared_ptr<Frame> GetFrame(std::shared_ptr<Frame> frame, int64_t frame_number);
/// Get and Set JSON methods
string Json(); ///< Generate JSON string of this object
void SetJson(string value); ///< Load JSON string into this object
Json::Value JsonValue(); ///< Generate Json::JsonValue for this object
void SetJsonValue(Json::Value root); ///< Load Json::JsonValue into this object
/// Get all properties for a specific frame (perfect for a UI to display the current state
/// of all properties at any time)
string PropertiesJSON(int64_t requested_frame);
};
}
#endif
openshot::EffectBase
This abstract class is the base class, used by all effects in libopenshot.
Definition: EffectBase.h:66
openshot
This namespace is the default namespace for all code in the openshot library.
Definition: AudioBufferSource.h:45
openshot::Keyframe
A Keyframe is a collection of Point instances, which is used to vary a number or property over time.
Definition: KeyFrame.h:64
openshot::Shift
This class shifts the pixels of an image up, down, left, or right, and can be animated with openshot:...
Definition: Shift.h:52
openshot::Shift::x
Keyframe x
Shift the X coordinates (left or right)
Definition: Shift.h:60
openshot::Shift::y
Keyframe y
Shift the Y coordinates (up or down)
Definition: Shift.h:61